#! /usr/bin/env python3

#installing all used packages
    #source: https://stackoverflow.com/questions/17271444/how-to-install-a-missing-python-package-from-inside-the-script-that-needs-it
try:
    import sys
except ImportError:
    import pip
    pip.main(['install', '--user', 'sys'])
    import sys
try:
    import psycopg2
except ImportError:
    import pip
    pip.main(['install', '--user', 'psycopg2'])
    import psycopg2
try:
    import csv
except ImportError:
    import pip
    pip.main(['install', '--user', 'csv'])
    import csv


#------------------------------------------------------------------------------------------------------------------------------------------

#Infos to connect to the Database
#eg:
# db_host = 'localhost'
# db_port = '5432'
# db_name = 'db01234567'
# db_user = 'postgres'
# db_password = '1234'

db_host = sys.argv[-5]
db_port = sys.argv[-4]
db_name = sys.argv[-3]
db_user = sys.argv[-2]
db_password = sys.argv[-1]
#print(db_host, ':', db_port, ':', db_name, ':', db_user, ':', db_password)

#names of the csv files which contain the data
airlines_csv_name = sys.argv[1]#'Airlines.csv'
airports_csv_name = sys.argv[2]#'Airports.csv'
planes_csv_name = sys.argv[3]#'Planes.csv'
routes_csv_name = sys.argv[4]#'Routes.csv'
#print(airlines_csv_name, airports_csv_name, planes_csv_name, routes_csv_name)

#------------------------------------------------------------------------------------------------------------------------------------------

#HELP:
'''
def functionality_test_function():
#creates a test table and inserts test data into it
#   if the table already exists the old one will be deleted first

    cur.execute('DROP TABLE IF EXISTS Test_table_TAs')
    cur.execute('CREATE TABLE Test_table_TAs(ta_id SERIAL PRIMARY KEY, first_name VARCHAR(256) NOT NULL, last_name VARCHAR(256) NOT NULL)')
    
    #fills table with data
    cur.execute('INSERT INTO Test_table_TAs (first_name, last_name) VALUES(%s, %s)',
                ('Dardan', 'Dermaku'))
    cur.execute('INSERT INTO Test_table_TAs (first_name, last_name) VALUES(%s, %s)',
                ('Olga', 'Ovcharenko'))
    cur.execute('INSERT INTO Test_table_TAs (first_name, last_name) VALUES(%s, %s)',
                ('Oliver', 'Nikolic'))
    cur.execute('INSERT INTO Test_table_TAs (first_name, last_name) VALUES(%s, %s)',
                ('Melanie', 'Willfurth'))
    
    #queries all information of the table and prints the returned data
    cur.execute('SELECT * FROM Test_table_TAs')
    the_list = cur.fetchall()
    print(the_list)

def delete_test_functions():
#reverses all the 'functionality_test_function()' has done
    cur.execute('DROP TABLE IF EXISTS Test_table_TAs')
'''


def csv_to_list(csv_name):
#gets data from the csv file and puts it into a list of lists
#for accessing the data: data_list[row_number][column_number]
    data_list = []
    with open(csv_name, 'r', encoding='utf-8') as csvfile:
      data_squads = csv.reader(csvfile)
      
      for row in data_squads:
        #to remove all the ', to have no collisions in the code later on
        new_row = []
        for element in row:
          if isinstance(element, str):
            element = element.replace("'", "`")
          new_row.append(element)
        #print(new_row)
            
        data_list.append(new_row)
      #deletes the fist row, which contains the table heads
      #optional:uncomment if this makes working with the data easier for you
      #del data_list[0]
    return data_list

def semicolon_string_to_list(string):
#interprets all ; of the given string as separator of elements
#returns a list of strings
    return string.split(';')

#------------------------------------------------------------------------------------------------------------------------------------------

#Lists from csvs
airlines_list = csv_to_list(airlines_csv_name)
airports_list = csv_to_list(airports_csv_name)
planes_list = csv_to_list(planes_csv_name)
routes_list = csv_to_list(routes_csv_name)




#SQL connection
sql_con = psycopg2.connect(host = db_host, port = db_port, database = db_name, user = db_user, password = db_password)
#cursor, for DB operations
cur = sql_con.cursor()


#------------------------------------------------------------------------------------------------------------------------------------------
##HELP: this part is just for testing your setup
#functionality_test_function()
#delete_test_functions()
#------------------------------------------------------------------------------------------------------------------------------------------




#commit the changes, this makes the database persistent
sql_con.commit()

#close connections
cur.close()
sql_con.close()
